/* Copyright 2004, 2005 Lei Zhang, Columbia University */
/* This file is part of THINC.

    THINC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    THINC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with THINC.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once
#include "tsnetwork.h"
#include "tscommon.h"
#include "thincCmdQue.h"


	void TServer(void);
	void TServerTearDown(void);

	HKEY hKeyProfileMirror;
	HKEY hKeyDevice;

	HDC mirrHdc;

	TSframeBuffer fb;
	TSCursor cursor;

	PThincCmdPtrQueue pCmdPtrQueue;
	PVOID pCmdBlock;
	PThincSignals	pSignals;

	HANDLE hEventNewCmd;		// Set when a new command is created; 
	HANDLE hEventBlockOnDraw;	// Wait before any drawing;
	HANDLE hEventStartBlocking;// Set before waiting on pEventBlockOnDraw
	HANDLE hEventRestart;	
	HANDLE hEventBlockOnCopy;	// Wait before copy; set by user mode server
	HANDLE hEventStartBlockingCopy;// Set before waiting on pEventBlockOnCopy

	HANDLE hEventClientData;
	HANDLE hEventClientDataPrivate;

	// Get the HDC of the mirror driver. Return true on success
	BOOL getMirrDC(void);
	LPSTR GetDispCode(INT code);
	BOOL releaseMirr(void);
	BOOL SendCmd(void* cmdData);

	BOOL Init(void);
	//BOOL Start(unsigned short port);
	DWORD WINAPI StartNew(LPVOID parameter);
	BOOL End(void);
