/* Copyright 2004, 2005 Lei Zhang, Columbia University */
/* This file is part of THINC.

    THINC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    THINC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with THINC.  If not, see <http://www.gnu.org/licenses/>.
*/
// ThincServConsole.cpp : Defines the entry point for the console application.
//

#include "TSNetwork.h"
#include "TServer.h"
#include "TSDebug.h"


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tchar.h>
#include "winsock2.h"

CHAR* programName;      // program name
HINSTANCE appInstance;  // handle to the application instance


int __cdecl main(int argc, char* argv[])
{							  
	LONG   dwThreadId;
	HANDLE hThread;
	WSADATA wsaData;
	int iResult;


	programName = *argv++;
    argc--;
	appInstance = GetModuleHandle(NULL);

	TSDebugStart(DEBUG_OVER_COUNT | DEBUG_STAT);
	TSInstrumentStart();

	// Initialize Winsock
	iResult = WSAStartup(MAKEWORD(2,2), &wsaData);
	if (iResult != NO_ERROR)
	{
		printf("Error at WSAStartup()\n");
		return 0;
	};

	printf("main() -- Winsock initialized\n");

	TServer();
	printf("main() -- TServer()\n");
	Init();
	printf("main() -- Init()\n");
	
	hThread = CreateThread(NULL, 0, StartNew, NULL, 0, &dwThreadId);
	//
	//SetThreadPriority(hThread, THREAD_PRIORITY_LOWEST);
	//// disable thread priority boosting
	//SetThreadPriorityBoost(hThread, TRUE);

	WaitForSingleObject(hThread, INFINITE); 

	//StartNew(NULL);

	printf("main() -- StartNew()\n");
	End();
	printf("main() -- End()\n");
	TServerTearDown();
	printf("main() -- TServerTearDown()\n");

	WSACleanup();
	printf("main() -- Winsock uninitialized\n");

	TSDebugEnd();
	TSInstrumentEnd();

    return 0;
}


