/* Copyright 2003, 2004, 2005 Ricardo Baratto */
/* This file is part of THINC.

    THINC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    THINC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with THINC.  If not, see <http://www.gnu.org/licenses/>.
*/

/******************************Module*Header*******************************\
*
*                       **************************
*                       * THINC Related Routines *
*                       **************************
*
* Module Name: thincDrvList.c
*
* This module contains the functions that are related with THINC 
*
* Copyright (c) Lei Zhang, Network Computing Labaratory, Columbia University
\**************************************************************************/


#include "thincCmdQue.h"


#define CQ_DBGLEV 10

#define containerPtr(structPtr, memberAddr, member)	\
	(structPtr)((char*)memberAddr - (int)(&(((NULL)(structPtr))->member)))

PThincCmdPtr popCmd(PThincCmdPtrQueue pThincCmdPtrQue)
{
	PThincCmdPtr ret = NULL;
	if (!QUEUEEMPTY(pThincCmdPtrQue))
	{
		ret = &(pThincCmdPtrQue->ThincCmdPtrList[pThincCmdPtrQue->cmdHeadIndex++]);
		pThincCmdPtrQue->cmdHeadIndex &= pThincCmdPtrQue->mask;
	}
	return ret;
}

BOOL queueFull(PThincCmdPtrQueue pThincCmdPtrQue)
{
	// Actually, the slot of ppThincCmdPtrQue[cmdHeadIndex-1] will never be used.
	// But don't worry, it is only a pointer. It doesn't waste too much space.
	return (pThincCmdPtrQue->cmdHeadIndex == ((pThincCmdPtrQue->cmdTailIndex+1) & pThincCmdPtrQue->mask));
}

