/******************************Module*Header*******************************\
*
*                       **************************
*                       * THINC Related Routines *
*                       **************************
*
* Module Name: thincDrvList.h
*
* This module contains the functions that are related with THINC 
*
* Copyright (c) Lei Zhang, Network Computing Labaratory, Columbia University
\**************************************************************************/

#ifndef _THINC_CMD_QUEUE_
#define _THINC_CMD_QUEUE_


#define MAX_CMD_QUEUE	0x200000		// This number must be the power of 2

#include "windows.h"

typedef struct ThincCmdPtr_s {
	PVOID			pCmdBlock;
	INT				offset;
} ThincCmdPtr, *PThincCmdPtr;

typedef struct ThincCmdPtrQueue_s {
	HANDLE		hSharedMem;
	PVOID		userVirtualAddress;
	INT			cmdHeadIndex, cmdTailIndex;
	INT			cmdQueueSize;	
	INT			mask;
	ThincCmdPtr	ThincCmdPtrList[MAX_CMD_QUEUE];
	// followed by size of display commands
} ThincCmdPtrQueue, *PThincCmdPtrQueue;

#define QUEUEFULL(p) (p->cmdHeadIndex == ((p->cmdTailIndex+1) & p->mask))
#define QUEUEEMPTY(p) (p->cmdHeadIndex == p->cmdTailIndex)
#define QUEUELENGTH(p) ((p->cmdTailIndex + p->cmdQueueSize - p->cmdHeadIndex)& p->mask)


PThincCmdPtr popCmd(PThincCmdPtrQueue pThincCmdPtrQue);
BOOL queueFull(PThincCmdPtrQueue pThincCmdPtrQue);


#endif /* _THINC_CMD_QUEUE_ */