/*
 *
 * Authentication functions for THINC
 *
 * Author:
 * Sheikh M. Omer-Farooq <smo2001@columbia.edu>
 * Columbia University
 */

/* set tabstop 8 */

#ifndef _THINC_AUTH_H_
#define _THINC_AUTH_H_

#ifndef T_WIN32
#include <security/pam_appl.h>
#endif

/* return values */
#define T_AUTH_OK	1
#define T_AUTH_ERROR	-1	/* general auth error */
#define T_AUTH_NOMATCH	-2	/* owner != user */

struct thinc_user {
	char* user;
	char* passwd;
	unsigned int user_len;
	unsigned int pass_len;
};

int thinc_authenticate(struct thinc_user* info, const char *owner, 
	unsigned int owner_len);
int thinc_get_user_info(struct thinc_user* info);
void thinc_free_user_info(struct thinc_user* info);
int thinc_get_owner(int uid, char **owner, unsigned int *len);

#endif
