/* Copyright 2004, 2005 Lei Zhang, Columbia University */
/* This file is part of THINC.

    THINC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    THINC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with THINC.  If not, see <http://www.gnu.org/licenses/>.
*/
/******************************Module*Header*******************************\
*
*                          *********************
*                          * THINC Driver CODE *
*                          *********************
*
* Module Name: bitblt.c
*
* This module contains the functions doing bit block transfer.
*
***************************************************************************/

#include "driver.h"
#include "rops.h"
#include "clip.h"
#include "MirrCmdProto.h"

#define COPYBITS_DBG_LEV 2


/******************************Public*Routine******************************\
* DrvCopyBits
*
\**************************************************************************/

/* refer to \mirror\disp\enable.c@line: 323 */
/* refer to \mirror\disp\enable.c@line: 324 */
/* refer to \mirror\disp\enable.c@line: 325 */
/* refer to \mirror\disp\enable.c@line: 326 */
/* refer to \mirror\disp\enable.c@line: 327 */
/* refer to \mirror\disp\enable.c@line: 328 */
/* refer to \mirror\disp\enable.c@line: 329 */
/* refer to \mirror\disp\enable.c@line: 330 */
/* refer to \mirror\disp\enable.c@line: 331 */
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 555 */ 
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 556 */
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 557 */

/******************************Public*Routine******************************\
* DrvBitBlt
*
\**************************************************************************/

/* refer to \mirror\disp\enable.c@line: 405 */
/* refer to \mirror\disp\enable.c@line: 406 */
/* refer to \mirror\disp\enable.c@line: 325 */
/* refer to \mirror\disp\enable.c@line: 408 */
/* refer to \mirror\disp\enable.c@line: 326 */
/* refer to \mirror\disp\enable.c@line: 327 */
/* refer to \mirror\disp\enable.c@line: 328 */
/* refer to \mirror\disp\enable.c@line: 412 */
/* refer to \mirror\disp\enable.c@line: 413 */
/* refer to \mirror\disp\enable.c@line: 414 */
/* refer to \mirror\disp\enable.c@line: 415 */
/* refer to \mirror\disp\enable.c@line: 416 */
/* refer to \mirror\disp\enable.c@line: 417 */
/* refer to \mirror\disp\enable.c@line: 418 */
	PMirrSurf   psurfDst, psurfSrc;
	PPDEV       ppdev = PPDEV_OF_PSURFOBJ(psoDst);

	BOOL        res;

	BOOL        doRawUpdate = FALSE;

	BOOL		doSFill = FALSE;
	ULONG		iSolidColor;

	BOOL		doPFill = FALSE;

	BOOL		doCopy = FALSE;
	BOOL		bBlockForCopy = FALSE;

/* refer to \3dlabs\perm3\disp\gdi\bitblt.c@line: 1555 */
	RECTL*		pRects = &rcl;
	LONG		lNumRects;
	BOOL		doFreeRectl;


/* refer to \3dlabs\perm3\disp\gdi\enable.c@line: 440 */
/* refer to \3dlabs\perm3\disp\gdi\enable.c@line: 441 */
		ppdev = PPDEV_OF_PSURFOBJ(psoSrc);
		ASSERT((ppdev != NULL), " ppdev should not be null\n");
	}

#if DBG
	TimeStamp(ppdev, TIME_STAMP_BEFORE_DRAWING, __FUNCTION__);		
#endif

	DISPDBG((COPYBITS_DBG_LEV-1, 
/* refer to \mirror\disp\enable.c@line: 422 */
/* refer to \mirror\disp\enable.c@line: 423 */ 
/* refer to \mirror\disp\enable.c@line: 424 */

	//BlockOnRequest(psoDst, psoSrc);


	ASSERT(!(rop4 & 0xFFFF0000), "DrvBitBlt: unexpected rop4 code");

	ASSERT((psoDst != NULL),			// psoDst will never be NULL. Double check to be safe.
		"DrvBitBlt: psoDst == NULL"); 
	psurfDst = (PMirrSurf)psoDst->dhsurf;
	
	if (psurfDst == NULL)	
	{
		//
		// GDI managed standard format bitmap
		//
		DISPDBG((COPYBITS_DBG_LEV, " DrvBitBlt: the destination surface is DIB\n"));
		goto punt;
	}

	//
	// Now the destionation surface is device managed 
	//

	//if (!(psurfDst->flags & SURF_FG_ONSCREEN))
	//{
	//	//
	//	// It is an offscreen surface. Set the updated flag
	//	// and punt it to GDI Engine.
	//	//
	//	DISPDBG((COPYBITS_DBG_LEV, " DrvBitBlt: the destination is an offscreen device managed surface.\n"));
	//	//psurfDst->flags |= FG_UPDATED;
	//	goto punt;
/* refer to \3dlabs\perm3\disp\inc\tvp3026.h@line: 455 */

	DISPDBG((COPYBITS_DBG_LEV, " DrvBitBlt: Now the destionation is on screen surface\n"));
	//
	// Now the destination is onscreen surface
	//

/* refer to \3dlabs\perm3\disp\gdi\bitblt.c@line: 689 */ 
/* refer to \3dlabs\perm3\disp\gdi\bitblt.c@line: 690 */
		psurfSrc = NULL;

		//
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 145 */
        //
		ASSERT((psurfDst != NULL),
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 148 */

/* refer to \3dlabs\perm2\disp\bitblt.c@line: 166 */
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 167 */
			//
			// A mask is required.
			// punt it and doing raw update. 
			//
			// FIXME: can we do some optimization here?
			//
			doRawUpdate = TRUE;
            goto punt;
        }

        //
/* refer to \3dlabs\perm3\disp\gdi\bitblt.c@line: 730 */
/* refer to \3dlabs\perm3\disp\gdi\bitblt.c@line: 731 */
        //
        ASSERT((((rop4 >> 2) ^ rop4) & 0x33) == 0,
/* refer to \3dlabs\perm3\disp\gdi\bitblt.c@line: 734 */
		
        //
/* refer to \3dlabs\perm3\disp\gdi\bitblt.c@line: 736 */
        //

/* refer to \3dlabs\perm2\disp\bitblt.c@line: 182 */
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 183 */
            //
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 185 */
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 186 */
            //
            
            //
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 190 */
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 191 */
            //
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 193 */
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 194 */
				//
				// I am unable to deal with this case now. Let's 
				// just make it simple.
				//
				doRawUpdate = TRUE;
				goto punt;

				//
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 196 */
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 197 */
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 198 */
                //

				//
				// Since we haven't hook the DrvRealizeBrush(), the program will
				// not come here, as I guess...
				// 
                if ( pbo->pvRbrush == NULL )
                {
					//
                    // get the brush can be realized.
					PVOID _brush = BRUSHOBJ_pvGetRbrush(pbo); 
                    if ( _brush == NULL )
                    {
                        //
/* refer to \3dlabs\perm3\disp\gdi\bitblt.c@line: 760 */
/* refer to \3dlabs\perm3\disp\gdi\bitblt.c@line: 761 */
/* refer to \3dlabs\perm3\disp\gdi\bitblt.c@line: 762 */
/* refer to \3dlabs\perm3\disp\gdi\bitblt.c@line: 763 */
/* refer to \3dlabs\perm3\disp\gdi\bitblt.c@line: 764 */
                        //
                        DISPDBG((COPYBITS_DBG_LEV, "DrvBitBlt: BRUSHOBJ_pvGetRbrush failed"));
						doRawUpdate = TRUE;
						goto punt;
                    }
                }
				else
				{
					//pb.pptlBrush = pptlBrush;
					//
					////
					//// Check if brush pattern is 1 BPP or not
					//// Note: This is set in DrvRealizeBrush
					////
					//if ( pb.prbrush->fl & RBRUSH_2COLOR )
					//{
					//    //
					//    // 1 BPP pattern. Do a Mono fill
					//    //
					//    pb.pgfn = vMonoPatFill;
/* refer to \3dlabs\perm3\disp\inc\tvp3026.h@line: 455 */
					//else
					//{
					//    pb.pgfn = vPatFill;
/* refer to \3dlabs\perm3\disp\inc\tvp3026.h@line: 455 */
/* refer to \3dlabs\perm3\disp\inc\tvp3026.h@line: 467 */
/* refer to \3dlabs\perm3\disp\inc\tvp3026.h@line: 473 */
            else
            {
				DISPDBG((COPYBITS_DBG_LEV, " DrvBitBlt: ulBitCount == %d, pbo->iSolidColor = %x\n" , 
					ppdev->ulBitCount, pbo->iSolidColor));
				ASSERT( ((ppdev->ulBitCount == 32) 
                    ||(pbo->iSolidColor&(0xFFFFFFFF<<ppdev->ulBitCount))==0),
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 241 */
               
				// Here is the color to fill
                iSolidColor = BRUSHOBJ_ulGetBrushColor(pbo);

				//
				// FIXME: I don't know why we need to swap the red and blue byte.
				// It is promised in MSDN that the color is translated to the 
				// target surface's palatte. But it is just not true.
				//

				SWAP_RED_BLUE(iSolidColor);

/* refer to \3dlabs\perm2\disp\bitblt.c@line: 245 */
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 246 */
                    //pb.pgfn = vSolidFillWithRop;

					//
					// I am unable to deal with this case now. Let's 
					// just make it simple.
					//
					doRawUpdate = TRUE;
					goto punt;

				}
                else
                {
                    //pb.pgfn = pb.ppdev->pgfnSolidFill;

					doSFill = TRUE;
					goto punt;
                }
            }        
		}// if ((((ucRop3 >> 4) ^ (ucRop3)) & 0xf) != 0)
        else
        {
            //
/* refer to \3dlabs\perm3\disp\gdi\bitblt.c@line: 789 */
            // only for rops 00, 55, AA and FF.
            //
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 261 */
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 262 */
                //pb.solidColor = 0;
                //pb.ulRop4 = ROP4_PATCOPY;

				iSolidColor = 0;
				doSFill = TRUE;
				goto punt;
            }
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 266 */
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 267 */
                //pb.solidColor = 0xffffff;
                //pb.ulRop4 = ROP4_PATCOPY;

				iSolidColor = 0xffffff;			
				doSFill = TRUE;
				goto punt;
            }
            else if ( rop4 == ROP4_NOP)
            {
                return TRUE;
            }
            else
            {
                //pb.pgfn = vInvert;
                //goto doIt;

				//
				// I am unable to deal with this case now. Let's 
				// just make it simple.
				//
				doRawUpdate = TRUE;
				goto punt;
            }
        }
	}// if (psoSrc == NULL)


	//
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 290 */
	//

	psurfSrc = (PMirrSurf)psoSrc->dhsurf;

	if (psoMask != NULL)
	{
		//
		// I am unable to deal with this case now. Let's 
		// just make it simple.
		//
		doRawUpdate = TRUE;
		goto punt;
	}
	
	//
	// Now we don't have a mask
	//
	
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 339 */
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 340 */
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 341 */
/* refer to \3dlabs\perm2\disp\bitblt.c@line: 342 */
        /*&& ((pxlo->pulXlate[1] & ppdev->ulWhite) == ppdev->ulWhite) */)
    {
		//
		// I am unable to deal with this case now. Let's 
		// just make it simple.
		//
		doRawUpdate = TRUE;
		goto punt;

		//
        // When the background and foreground colors are black and
        // white, respectively, and the ROP is 0xb8 or 0xe2, and
        // the source bitmap is monochrome, the blt is simply a
        // color expanding monochrome blt.
        //
        //
        // Rather than add another parameter to 'pfnXfer', we simply
        // overload the 'pxlo' pointer.  Note that we still have to
        // special-case 0xb8 and 0xe2 in our 'pfnXfer1bpp' routine
        // to handle this convention:
        //

		//xloTmp = *pxlo;
  //      xloTmp.pulXlate = aulTmp;
  //      aulTmp[0] = pbo->iSolidColor;
  //      aulTmp[1] = pbo->iSolidColor;
  //      
  //      pb.pxlo = &xloTmp;
  //      DBG_GDI((6, "Rop is 0x%x", pb.ulRop4));
  //      pb.pgfn = vMonoDownload;
  //      pb.psoSrc = psoSrc;
		
    }

	if (pbo != NULL)
	{
		//
		// I am unable to deal with this case now. Let's 
		// just make it simple.
		//
		doRawUpdate = TRUE;
		goto punt;
	}

    //
    // After this point we know we do not have a brush
    //


    //
    // We have a source to dest rop2 operation
    //

	if (psurfSrc == NULL)
	{
		//
		// It is a standard format bitmap managed by GDI
		//
		doRawUpdate = TRUE;
		goto punt;



        //pb.psoSrc = psoSrc;

        //if(psoSrc->iBitmapFormat == BMF_1BPP)
        //{
        //    pb.pxlo = pxlo;
        //    pb.pgfn = vMonoDownload;
        //                
        //    goto doIt;

        //}
        //else if(psoSrc->iBitmapFormat == pb.ppdev->iBitmapFormat 
        //         && (pxlo == NULL || pxlo->flXlate == XO_TRIVIAL) )
        //{

        //    pb.psoSrc = psoSrc;
        //    pb.pgfn = vDownloadNative;

        //    goto doIt;
        //}    
        //else
        //{
        //    goto puntIt;
        //}
 
	}
	else if (psurfSrc->flags & SURF_FG_ONSCREEN) 
	{
		//
		// Both source and destionation surfaces are onscreen
		//


		//if( pxlo != NULL && !(pxlo->flXlate & XO_TRIVIAL))
		//{
		//	doRawUpdate = TRUE;
		//	goto punt;
		//}

		doCopy = TRUE;
		if (psurfDst->flags & SURF_FG_ONSCREEN) 
		{
			// only block for onscreen to onscreen copy
			bBlockForCopy = TRUE;
		}
		//doRawUpdate = TRUE;
		goto punt;

		//if ( (rop4 == ROP4_SRCCOPY) || (psoSrc == psoDst) )
		//{
		//	if ( pb.psurfSrc->ulPixDelta == pb.psurfDst->ulPixDelta )
		//	{
		//		pb.pgfn = vCopyBltNative;
		//	}
		//	else
		//	{
		//		pb.pgfn = vCopyBlt;
		//	}
		//}
		//else
		//{
		//	pb.pgfn = vRop2Blt;
		//}

	}
	else if (!(psurfSrc->flags & SURF_FG_ONSCREEN) )
	{
		doCopy = TRUE;
		//if (psurfDst->flags & SURF_FG_ONSCREEN)
		//{
		//	bBlockForCopy = TRUE;
		//}
		//doRawUpdate = TRUE;
		goto punt;
	}

	doRawUpdate = TRUE;
	goto punt;


////////////////////////////////////////////////////////////////////////
	

punt:
	pRects = NULL;

	vClip(pco,
		NULL,	//prclSrc, 
		prclDst, 
		pptlSrc,
		&pRects,
		&lNumRects,
		psurfSrc,
		psurfDst);

	if (doSFill)
	{
		SolidFill(psurfDst, iSolidColor, lNumRects, pRects);
//		int			i, datasize, offset;
//		PVOID		data, pscan;
//		RECTL*		prct;
//		PThincCmd	pCmd;
//		INT			pixelbits = psurfDst->ulBitCount;
//					
//		MirrCmdHeader* header;
//		thinc_fbSFill* fbsfill;
//
//		thinc_rectRegion* ptRects, *ptrct;
//
//		DISPDBG((COPYBITS_DBG_LEV, "doSFill == true, lNumRects = %d\n", lNumRects));
//
//		datasize = THINC_HEADERSIZE + T_FB_SFILL_SIZE + lNumRects * T_RECTREGION_SIZE;
//
//		pCmd = thincCmdBlockAlloc(&(ppdev->pCmdBlock), datasize, &offset);
//
//		if (pCmd != NULL) 
//		{
//			data = pCmd->cmdData;
//			header = (MirrCmdHeader*)data;
//			header->type = T_FB_SFILL;
//			header->dstId = psurfDst->id;
//			header->srcId = NULL_SURF_ID;
//
//			DISPDBG((COPYBITS_DBG_LEV, " DrvBitBlt: data allocation succeed. data_size = %d\n", datasize));
//
//			fbsfill = (thinc_fbSFill*)((char*)data + THINC_HEADERSIZE);
//			fbsfill->numrects = lNumRects;
//			fbsfill->pixel = iSolidColor;
//
//			ptRects = (thinc_rectRegion*)((char*)data + THINC_HEADERSIZE + T_FB_SFILL_SIZE);
//			for (i = 0; i < lNumRects; i++)
//			{
//				prct = &pRects[i];
//				ptrct = &ptRects[i];
//				ptrct->x = prct->left;
//				ptrct->y = prct->top;
//				ptrct->height = prct->bottom - prct->top;
//				ptrct->width = prct->right - prct->left;
//			}
////			if (!pushCmdWithOffset(psurfDst->ppdev->pCmdPtrQueue, psurfDst->pCurrentCmdBlock, offset))
//			if (!thincPushCmdWithOffset(psurfDst->ppdev, psurfDst->ppdev->pCmdBlock, offset))
//			{
//				DISPDBG((1, "  DrvBitBlt -- pushing command failed\n")); 
//				EngFreeMem(data);
//			}					   
	//}
	}
	else if (doCopy)
	{
		//
		// The copy command needs no the information of image. Therefore, 
		// we push the commands into command queue before punt it to GDI Engine.
		//

		int        i, datasize, offset;
		PVOID      data;
		RECTL*     rct;
		PThincCmd	pCmd;


		DISPDBG((COPYBITS_DBG_LEV, "doCopy == true, lNumRects = %d\n", lNumRects));

		for (i = 0; i < lNumRects; i++)
		{
			MirrCmdHeader* header;
			thinc_fbCopy* fbcopy;

			rct = &pRects[i];
			datasize = THINC_HEADERSIZE + T_FB_COPY_SIZE;

			pCmd = thincCmdBlockAlloc(&(ppdev->pCmdBlock), datasize, &offset);

			if (pCmd != NULL) 
			{
				data = pCmd->cmdData;
				header = (MirrCmdHeader*)data;

				header->type = T_FB_COPY;
				header->dstId = psurfDst->id;
				header->srcId = psurfSrc->id;

				ASSERT((pptlSrc != NULL), 
					" DrvBitBlt: doCopy == True. pptlSrc == NULL\n");
			
				fbcopy = (thinc_fbCopy*)((char*)data + THINC_HEADERSIZE);
				
				fbcopy->sx = pptlSrc->x + (rct->left - prclDst->left);
				fbcopy->sy = pptlSrc->y + (rct->top - prclDst->top);
				fbcopy->dx = rct->left;
				fbcopy->dy = rct->top;
				fbcopy->height = rct->bottom - rct->top;
				fbcopy->width = rct->right - rct->left;

				ASSERT((!bBlockForCopy || (psurfDst->id == psurfSrc->id)),
					" DrvBitBlt: bBlockForCopy == true, psurfDst != psurfSrc\n");

				if (ppdev->bServerOn && bBlockForCopy)
				{
					ppdev->thincSignals.bStatusBlockBeforeCopy = TRUE;
				}

#ifdef TIME_STAMP
				// Time stamp the command
				ppdev->pfQuerySystemTime(&pCmd->timeStamp[0]);
#endif

				if (!thincPushCmdWithOffset(ppdev, ppdev->pCmdBlock, offset))
				{
					DISPDBG((1, "  DrvBitBlt -- pushing command failed\n")); 
					EngFreeMem(data);
				}					   
				if (ppdev->bServerOn && bBlockForCopy)
				{
					LARGE_INTEGER timeout;									    
					int counter = 0;
					timeout.QuadPart = -TIME_OUT;								
					while (ppdev->thincSignals.bStatusBlockBeforeCopy)
					{
						counter++;
						ppdev->pfResetEvent(ppdev->pEventBlockOnCopy);
						ppdev->pfWaitOnEvent(ppdev->pEventBlockOnCopy, &timeout);
						if (counter>100)
							break;
					}
				}
			} 
			else 
			{
				DISPDBG((COPYBITS_DBG_LEV, " DrvBitBlt: command data allocation failed\n"));
			}
		}
#if 0
		if (ppdev->bServerOn && bBlockForCopy)
		{
			LARGE_INTEGER timeout;									    
#if 0
			timeout.QuadPart = -TIME_OUT;								
			ppdev->thincSignals.bStatusBlockBeforeCopy = TRUE;
			ppdev->pfSetEvent(ppdev->pEventNewCmd);
			ppdev->pfWaitOnEvent(ppdev->pEventBlockOnCopy, &timeout);
#else
			int counter = 0;
			timeout.QuadPart = -10000000;
			ppdev->thincSignals.bStatusBlockBeforeCopy = TRUE;
			while (ppdev->thincSignals.bStatusBlockBeforeCopy)
			{
				counter++;
				ppdev->pfResetEvent(ppdev->pEventBlockOnCopy);
				ppdev->pfWaitOnEvent(ppdev->pEventBlockOnCopy, &timeout);
				if (counter>300)
					break;
			}
#endif
		}
#endif
	}
	START_DRAWING;

	res = EngBitBlt(psoDst, 
					psoSrc,
					psoMask,
					pco,
					pxlo,
					prclDst,
					pptlSrc,
					pptlMask,
					pbo,
					pptlBrush,
					rop4);

	FINISH_DRAWING;
		
	DISPDBG((COPYBITS_DBG_LEV, "EngBitblt was called.\n"));

	if (doRawUpdate)
	{
		int i;

		DISPDBG((COPYBITS_DBG_LEV, "doRawUpdate == true, lNumRects = %d\n", lNumRects));

		for (i = 0; i < lNumRects; i++)
		{
			RawUpdate(psoDst, &pRects[i]);
   		}
	}

	vFreeRectList(&pRects);

	return res;
}
