/* Copyright 2004, 2005 Lei Zhang, Columbia University */
/* This file is part of THINC.

    THINC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    THINC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with THINC.  If not, see <http://www.gnu.org/licenses/>.
*/
/******************************Module*Header*******************************\
*
*                          *********************
*                          * THINC Driver CODE *
*                          *********************
*
* Module Name: storke.c
*
* This module contains the functions for stroke path.
*
***************************************************************************/

//#define DBG 1
#define STROKE_DBG_LEV 2

#include "driver.h"
#include "clip.h"

BOOL
DrvStrokePath(SURFOBJ*   psoDst,
/* refer to \mirror\disp\enable.c@line: 512 */
/* refer to \mirror\disp\enable.c@line: 513 */
/* refer to \mirror\disp\enable.c@line: 514 */
/* refer to \mirror\disp\enable.c@line: 515 */
/* refer to \mirror\disp\enable.c@line: 516 */
/* refer to \mirror\disp\enable.c@line: 517 */
/* refer to \mirror\disp\enable.c@line: 518 */
/* refer to \mirror\disp\enable.c@line: 519 */
	PMirrSurf	psurfDst = (PMirrSurf)(psoDst->dhsurf);
	PPDEV		ppdev = (PPDEV)(psoDst->dhpdev);
	BOOL		res;
	BOOL		doRawUpdate = FALSE;

	int			i;
	int			lNumRects = 0;

	RECTL*		pRects = NULL;


	DISPDBG((1,
/* refer to \mirror\disp\enable.c@line: 521 */

	if (psurfDst == 0)
	{
		//
		// It is a DIB, not a device managed surface
		//
		goto punt;
	}


#if DBG
	TimeStamp(ppdev, TIME_STAMP_BEFORE_DRAWING, __FUNCTION__);		
#endif

	doRawUpdate = TRUE;
	vClip(pco,
		NULL,	//prclSrc, 
		NULL, 
		NULL,
		&pRects,
		&lNumRects,
		NULL,
		psurfDst);

punt:
	START_DRAWING;
	res = EngStrokePath(psoDst,
		ppo,
		pco,
		pxo,
		pbo,
		pptlBrush,
		pLineAttrs,
		mix);
	FINISH_DRAWING;

	if (doRawUpdate)
	{
		for (i = 0; i < lNumRects; i++)
		{
			RawUpdate(psoDst, &pRects[i]);
   		}
		vFreeRectList(&pRects);
	}

	return res;
}

