/* Copyright 2004, 2005 Lei Zhang, Columbia University */
/* This file is part of THINC.

    THINC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    THINC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with THINC.  If not, see <http://www.gnu.org/licenses/>.
*/
/******************************Module*Header*******************************\
*
*                          *********************
*                          * THINC Driver CODE *
*                          *********************
*
* Module Name: textout.c
*
* This module contains the functions doing text output.
*
\**************************************************************************/

#define TEXT_DBG_LEV 2

#include "driver.h"
#include "clip.h"
#include "MirrCmdProto.h"
BOOL bOutputNum = FALSE;
INT  iOutputCount = 0;
#if 0
BOOL bGetClippedGlyphs(SURFOBJ* psoDst,
/* refer to \3dlabs\perm2\disp\text.h@line: 25 */ 
					   LONG		cGlyph, 
					   ULONG	ulCharInc, 
					   RECTL*	pClippingRects, 
					   LONG		lNumRects,
					   ULONG	ulForeColor)
{
    PDEV*		ppdev = PPDEV_OF_PSURFOBJ(psoDst);
	PMirrSurf	psurfDst = (PMirrSurf)(psoDst->dhsurf);
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 135 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 136 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 137 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 138 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 139 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 140 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 141 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 142 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 143 */

/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 148 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 149 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 150 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 151 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 152 */

/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 154 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 155 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 156 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 148 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 149 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 159 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 160 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 161 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 162 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 163 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 164 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 165 */

/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 167 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 168 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 169 */

/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 184 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 185 */

		//
		// do Glyph
		//
		do
		{
			int			i, datasize, offset;
			PVOID		data, pscan;
			RECTL*		prct;
			char*		bitmap;
			int			bitmapSize;
			PThincCmd	pCmd;

			RECTL*		pRects = NULL;
			
			RECTL		glyphRect;

			MirrCmdHeader* header;
			thinc_fbGlyph* fbglyph;

			thinc_rectRegion* ptRects, *ptrct;

			DISPDBG((TEXT_DBG_LEV, "doSFill == true, lNumRects = %d\n", lNumRects));

			if (pClippingRects != NULL && lNumRects != 0)
			{
				//
				// Make a private copy of the rectangle list, which is for clipping
				//
				pRects = EngAllocMem(
							FL_NONPAGED_MEMORY,
							lNumRects * sizeof(RECTL),
							MKTAG("TXTO"));
				
				if (pRects == NULL) 
				{
					break;
				}
							
				memcpy(pRects, pClippingRects, lNumRects * sizeof(RECTL));

				//
				// the glyph rectange
				//
				glyphRect.left = x;
				glyphRect.top = y;
				glyphRect.right = x + cxGlyph;
				glyphRect.bottom = y + cyGlyph;

				//
				// clip the glyph with clipping rectangles
				//
				lNumRects = cIntersect(&glyphRect, pRects, lNumRects);
			}

			bitmapSize = cjGlyph;

			datasize = THINC_HEADERSIZE 
					+ T_FB_GLYPH_SIZE 
					+ bitmapSize
					+ lNumRects * T_RECTREGION_SIZE;
			
			pCmd = thincCmdBlockAlloc(&(ppdev->pCmdBlock), datasize, &offset);
			
			if (pCmd != NULL) 
			{
				INT screenstride;
				data = pCmd->cmdData;
				header = (MirrCmdHeader*)data;
				header->type = T_FB_GLYPH;
				header->dstId = psurfDst->id;
				header->srcId = NULL_SURF_ID;
				
				DISPDBG((TEXT_DBG_LEV, " bGetClippedGlyphs: data allocation succeed. data_size = %d\n", datasize));

				fbglyph = (thinc_fbGlyph*)((char*)data + THINC_HEADERSIZE);
				fbglyph->numrects = lNumRects;

				fbglyph->color = ulForeColor;
				fbglyph->x = x;
				fbglyph->y = y;
				fbglyph->width = cxGlyph;
				fbglyph->height = cyGlyph;

				bitmap = (char*)data + THINC_HEADERSIZE + T_FB_GLYPH_SIZE;
				memcpy(bitmap, pulGlyph, bitmapSize);

				ptRects = (thinc_rectRegion*)((char*)data + THINC_HEADERSIZE + T_FB_GLYPH_SIZE + bitmapSize);
				for (i = 0; i < lNumRects; i++)
				{
					prct = &pRects[i];
					ptrct = &ptRects[i];
					ptrct->x = prct->left;
					ptrct->y = prct->top;
					ptrct->height = prct->bottom - prct->top;
					ptrct->width = prct->right - prct->left;
				}
#ifdef TIME_STAMP
				// Time stamp the command
				ppdev->pfQuerySystemTime(&pCmd->timeStamp[0]);
#endif
				if (!thincPushCmdWithOffset(ppdev, ppdev->pCmdBlock, offset))
				{
					DISPDBG((1, " DrvTextOut: pushing command failed\n")); 
				}
			}

			if (pRects != NULL)
			{
				EngFreeMem(pRects);
			}
		} 

		while(FALSE);
    }

/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 214 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 215 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 216 */



#endif

BOOL bGetGlyphsContainer(SURFOBJ* psoDst,
/* refer to \3dlabs\perm2\disp\text.h@line: 25 */ 
					   LONG		cGlyph, 
					   ULONG	ulCharInc,
					   int *	resX,
					   int *	resY,
					   int *	resW,
					   int *	resH)
{
    PDEV*		ppdev = PPDEV_OF_PSURFOBJ(psoDst);
	PMirrSurf	psurfDst = (PMirrSurf)(psoDst->dhsurf);
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 135 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 136 */
    LONG        x, y, x2, y2;
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 138 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 139 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 140 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 141 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 142 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 143 */

	int top = psurfDst->cy;
	int bottom = 0;
	int left = psurfDst->cx;
	int right = 0;

/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 146 */

/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 148 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 149 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 150 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 151 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 152 */

/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 154 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 155 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 156 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 148 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 149 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 159 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 160 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 161 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 162 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 163 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 164 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 165 */

/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 167 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 168 */

		x2 = x + cxGlyph;
		y2 = y + cyGlyph;
		left = min(x, left);
		right = max(x2, right);
		top = min(y, top);
		bottom = max(y2, bottom);
    }

	*resX = left;
	*resY = top;
	*resW = right - left;
	*resH = bottom - top;

    return(TRUE);
}



/******************************Public*Routine******************************\
* DrvTextOut
*
\**************************************************************************/
/* refer to \mirror\disp\enable.c@line: 490 */
/* refer to \mirror\disp\enable.c@line: 406 */
/* refer to \mirror\disp\enable.c@line: 492 */
/* refer to \mirror\disp\enable.c@line: 493 */
/* refer to \mirror\disp\enable.c@line: 326 */
/* refer to \mirror\disp\enable.c@line: 495 */
/* refer to \mirror\disp\enable.c@line: 496 */
/* refer to \mirror\disp\enable.c@line: 497 */
/* refer to \mirror\disp\enable.c@line: 498 */
/* refer to \mirror\disp\enable.c@line: 499 */
/* refer to \mirror\disp\enable.c@line: 500 */
/* refer to \mirror\disp\enable.c@line: 501 */
/* refer to \mirror\disp\enable.c@line: 502 */
	PMirrSurf	psurfDst = (PMirrSurf)(psoDst->dhsurf);
	PPDEV		ppdev = PPDEV_OF_PSURFOBJ(psoDst);
	BOOL		res;
	BOOL		doRawUpdate = FALSE;
	BOOL		doSFill = FALSE;

	BYTE		iDComplexity;
	ULONG		iSolidColor;
	ULONG		ulForeColor;

	BOOL		bRet;

	RECTL*		pRects = NULL;
	int			lNumRects = 0;

    ULONG       cGlyph;
    BOOL        bMoreGlyphs;
    GLYPHPOS*   pgp;

	int			i, j, datasize,
				pixelbits, screenstride, stride;
			
	PVOID		data, pscan;
	RECTL*		rct;

	char		c;
	char*		p ;
	int			k;

	DISPDBG((1,
/* refer to \mirror\disp\enable.c@line: 504 */
/* refer to \mirror\disp\enable.c@line: 505 */

	if (psurfDst == 0)
	{
		//
		// It is a DIB, not a device managed surface
		//
		goto punt;
	}


#if DBG
	TimeStamp(ppdev, TIME_STAMP_BEFORE_DRAWING, __FUNCTION__);		
#endif

	ASSERT((mix == 0x0d0d), "GDI should only give us a copy mix");
	ASSERT((pco != NULL), "Expect non-null pco");

/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 447 */

/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 449 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 450 */
		// 
		// Do Solid Fill with pboOpaque. It is always a solid color brush
		//
		
		iSolidColor = BRUSHOBJ_ulGetBrushColor(pboOpaque);

		//
		// FIXME: I don't know why we need to swap the red and blue byte.
		// It is promised in MSDN that the color is translated to the 
		// target surface's palatte. But it just not true.
		//

		SWAP_RED_BLUE(iSolidColor);

		vClip(pco, 
			NULL, //prclSrc
			prclOpaque, 
			NULL, //
			&pRects,
			&lNumRects,
			NULL,
			psurfDst);

		doSFill = TRUE;

	}

	if (doSFill) 
	{
		SolidFill(psurfDst, iSolidColor, lNumRects, pRects);
	} 

	vFreeRectList(&pRects);

	//
	// Start rendering glyph
	//

	ulForeColor = BRUSHOBJ_ulGetBrushColor(pboFore);

	//
	// FIXME: I don't know why we need to swap the red and blue byte.
	// It is promised in MSDN that the color is translated to the 
	// target surface's palatte. But it just not true.
	//

	SWAP_RED_BLUE(ulForeColor);


/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 458 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 459 */
		int left = psurfDst->cx;
		int right = 0;
		int top = psurfDst->cy;
		int bottom = 0;
		RECTL rct;
/* refer to \3dlabs\perm3\mini\interupt.c@line: 286 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 508 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 509 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 510 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 511 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 512 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 513 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 514 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 515 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 516 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 518 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 519 */

/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 521 */
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 522 */
				int x, y, w, h;

				bRet = bGetGlyphsContainer(psoDst, pgp, cGlyph, pstro->ulCharInc,
					&x, &y, &w, &h);

				top = min(top, y);
				bottom = max(bottom, y+h);
				left = min(left, x);
				right = max(right, x+w);

			}
/* refer to \3dlabs\perm3\disp\gdi\textout.c@line: 534 */
		START_DRAWING;
		res = EngTextOut(
			psoDst,
			pstro,
			pfo,
			pco,
			prclExtra,
			prclOpaque,
			pboFore,
			pboOpaque,
			pptlOrg,
			mix);
		FINISH_DRAWING;

		rct.top = top;
		rct.bottom = bottom;
		rct.left = left;
		rct.right = right;

		Glyph(ppdev, psoDst, &rct, ulForeColor);

		if (bOutputNum)
		{
			DISPDBG((0,"1 "));
			if ((iOutputCount++ & 0x01F )== 0)
			{
				DISPDBG((0,"\n"));
			}
		}
	}
	else
	{
		int left = psurfDst->cx;
		int right = 0;
		int top = psurfDst->cy;
		int bottom = 0;
		RECTL rct;

		vClip(
			pco,
			NULL,	
			NULL,
			NULL,
			&pRects,
			&lNumRects,
			NULL,
			psurfDst);
		START_DRAWING;
		res = EngTextOut(
			psoDst,
			pstro,
			pfo,
			pco,
			prclExtra,
			prclOpaque,
			pboFore,
			pboOpaque,
			pptlOrg,
			mix);
		FINISH_DRAWING;
		if (bOutputNum)
		{
			DISPDBG((0,"%d ", lNumRects));
			if ((iOutputCount++ & 0x01F )== 0)
			{
				DISPDBG((0,"\n"));
			}
		}
#if 1
		for (i = 0; i < lNumRects; i++)
		{
			Glyph(ppdev, psoDst, &pRects[i], ulForeColor);
		}
#else
		for (i = 0; i < lNumRects; i++)
		{
			left = min(left, pRects[i].left);
			right = max(right, pRects[i].right);
			top = min(top, pRects[i].top);
			bottom = min(bottom, pRects[i].bottom);
		}
		rct.left = left;
		rct.right = right;
		rct.top = top;
		rct.bottom = bottom;
		Glyph(ppdev, psoDst, &rct, ulForeColor);
#endif
		vFreeRectList(&pRects);
		return res;
	}
punt:
		START_DRAWING;
		res = EngTextOut(
			psoDst,
			pstro,
			pfo,
			pco,
			prclExtra,
			prclOpaque,
			pboFore,
			pboOpaque,
			pptlOrg,
			mix);
		FINISH_DRAWING;
		return res;
}

