/* Copyright 2004, 2005 Lei Zhang, Columbia University */
/* This file is part of THINC.

    THINC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    THINC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with THINC.  If not, see <http://www.gnu.org/licenses/>.
*/
/******************************Module*Header*******************************\
*
*                           *********************
*                           * THINC header file *
*                           *********************
*
* Module Name: thincDrvList.h
*
* This module contains the functions that are related with THINC 
*
***************************************************************************/

#ifndef _THINC_CMD_QUEUE_
#define _THINC_CMD_QUEUE_

#include "driver.h"

#define MAX_CMD_QUEUE	0x200000		// This number must be the power of 2


typedef struct ThincCmdPtr_s {
	PThincCmdBlock	pCmdBlock;
	INT				offset;
} ThincCmdPtr, *PThincCmdPtr;

typedef struct ThincCmdPtrQueue_s {
	HANDLE		hSharedMem;
	PVOID		userVirtualAddress;
	INT			cmdHeadIndex, cmdTailIndex;
	INT			cmdQueueSize;	
	INT			mask;
	ThincCmdPtr	ThincCmdPtrList[0];
	// followed by size of display commands
} ThincCmdPtrQueue, *PThincCmdPtrQueue;

#define QUEUEFULL(p) (p->cmdHeadIndex == ((p->cmdTailIndex+1) & p->mask))
#define QUEUEEMPTY(p) (p->cmdHeadIndex == p->cmdTailIndex)
#define QUEUELENGTH(p) ((p->cmdTailIndex + p->cmdQueueSize - p->cmdHeadIndex)& p->mask)


VOID thincInitCmdQueue(PThincCmdPtrQueue pThincCmdPtrQueue);
INT thincCreateCmdQueue(PThincCmdPtrQueue* ppThincCmdPtrQueue);
BOOL pushCmd(PThincCmdPtrQueue pThincCmdPtrQue, ThincCmdPtr cmd);
BOOL thincPushCmdWithOffset(PPDEV ppdev, PThincCmdBlock pCmdBlock, INT offset);
BOOL pushCmdWithOffset(PThincCmdPtrQueue pThincCmdPtrQue, PThincCmdBlock pCmdBlock, INT offset);
PThincCmdPtr popCmd(PThincCmdPtrQueue pThincCmdPtrQue);
BOOL queueFull(PThincCmdPtrQueue pThincCmdPtrQue);


#endif /* _THINC_CMD_QUEUE_ */
